#include "init.h"

void
swf_no_bitmap()
{
	rb_raise(rb_eRuntimeError, "already closed bitmap");
}

static void
swf_free_bitmap(p)
	SWFBitmap p;
{
	Debug("swf free bitmap");
	destroySWFBitmap(p);
}

static VALUE
swf_bitmap_new(argc, argv, self)
	int argc;
	VALUE* argv;
	VALUE self;
{
	VALUE obj;
	VALUE name, mask;
	char *fname, *alpha;
	
	SWFBitmap p;
	
	argc = rb_scan_args(argc, argv, "11", &name, &mask);
	fname = STR2CSTR(name);
	if (argc > 1)
		alpha = STR2CSTR(mask);
	else
		alpha = NULL;
	
	if (strlen(fname) > 4) {
		if (strcmp(fname+strlen(fname)-4, ".dbl") == 0) {
			p = newSWFDBLBitmap(fopen(fname, "rb"));
		}
		else
		if (strcmp(fname+strlen(fname)-4, ".jpg") == 0) {
			if (alpha != NULL)
				p = newSWFJpegWithAlpha(fopen(fname, "rb"), fopen(alpha, "rb"));
			else
				p = newSWFJpegBitmap(fopen(fname, "rb"));
		}
		else
			rb_raise(rb_eStandardError, "ext");
	}
	obj = Data_Wrap_Struct(self, 0, swf_free_bitmap, p);
	return obj;
}

VALUE
swf_bitmap_alloc(self, p)
	VALUE self;
	SWFBitmap p;
{
	VALUE obj;
	
	obj = Data_Wrap_Struct(self, 0, 0, p);
	return obj;
}

static VALUE
swf_bitmap_width(self)
	VALUE self;
{
	SWFBitmap p;
	
	GetBitmap(self, p);
	return INT2FIX(SWFBitmap_getWidth(p));
}

static VALUE
swf_bitmap_height(self)
	VALUE self;
{
	SWFBitmap p;
	
	GetBitmap(self, p);
	return INT2FIX(SWFBitmap_getHeight(p));
}

void
swf_init_bitmap()
{
	cSwf_bitmap = rb_define_class_under(mSwf, "Bitmap", rb_cObject);
	rb_define_singleton_method(cSwf_bitmap, "new", swf_bitmap_new, -1);
	rb_define_method(cSwf_bitmap, "width", swf_bitmap_width, 0);
	rb_define_method(cSwf_bitmap, "height", swf_bitmap_height, 0);
}
