#include "init.h"

void
swf_no_button()
{
	rb_raise(rb_eRuntimeError, "already closed button");
}

static void
swf_free_button(p)
	SWFButton p;
{
	Debug("swf free button");
	destroySWFButton(p);
}

static VALUE
swf_button_new(self)
	VALUE self;
{
	VALUE obj;
	SWFButton p;
	
	p = newSWFButton();
	obj = Data_Wrap_Struct(self, 0, swf_free_button, p);
	return obj;
}

VALUE
swf_button_alloc(self, p)
	VALUE self;
	SWFButton p;
{
	VALUE obj;
	
	obj = Data_Wrap_Struct(self, 0, 0, p);
	return obj;
}

static VALUE
swf_button_add_shape(self, v, flags)
	VALUE self, v, flags;
{
	SWFButton p;
	SWFCharacter p_character;
	
	GetButton(self, p);
	GetCharacter(v, p_character);
	SWFButton_addShape(p, p_character, (byte)FIX2INT(flags));
	return v;
}

static VALUE
swf_button_set_hit(self, v)
	VALUE self, v;
{
	SWFButton p;
	SWFCharacter p_character;
	
	GetButton(self, p);
	GetCharacter(v, p_character);
	SWFButton_addShape(p, p_character, SWFBUTTON_HIT);
	return v;
}

static VALUE
swf_button_set_down(self, v)
	VALUE self, v;
{
	SWFButton p;
	SWFCharacter p_character;
	
	GetButton(self, p);
	GetCharacter(v, p_character);
	SWFButton_addShape(p, p_character, SWFBUTTON_DOWN);
	return v;
}

static VALUE
swf_button_set_over(self, v)
	VALUE self, v;
{
	SWFButton p;
	SWFCharacter p_character;
	
	GetButton(self, p);
	GetCharacter(v, p_character);
	SWFButton_addShape(p, p_character, SWFBUTTON_OVER);
	return v;
}

static VALUE
swf_button_set_up(self, v)
	VALUE self, v;
{
	SWFButton p;
	SWFCharacter p_character;
	
	GetButton(self, p);
	GetCharacter(v, p_character);
	SWFButton_addShape(p, p_character, SWFBUTTON_UP);
	return v;
}

static VALUE
swf_button_add_action(self, v, flags)
	VALUE self, v, flags;
{
	SWFButton p;
	SWFAction p_action;
	
	GetButton(self, p);
	GetAction(v, p_action);
	
	SWFButton_addAction(p, p_action, FIX2INT(flags));
	return Qnil;
}

static VALUE
swf_button_key_press(self, c)
	VALUE self, c;
{
	return INT2FIX(SWFBUTTON_KEYPRESS(NUM2CHR(c)));
}

void
swf_init_button()
{
	cSwf_button = rb_define_class_under(mSwf, "Button", rb_cObject);
	rb_define_singleton_method(cSwf_button, "new", swf_button_new, 0);
	rb_define_method(cSwf_button, "add_shape", swf_button_add_shape, 2);
	rb_define_method(cSwf_button, "hit=", swf_button_set_hit, 1);
	rb_define_method(cSwf_button, "down=", swf_button_set_down, 1);
	rb_define_method(cSwf_button, "over=", swf_button_set_over, 1);
	rb_define_method(cSwf_button, "up=", swf_button_set_up, 1);
	rb_define_method(cSwf_button, "add_action", swf_button_add_action, 2);
	rb_define_module_function(cSwf_button, "key_press", swf_button_key_press, 1);
	
	rb_define_const(cSwf_button, "HIT", INT2FIX(SWFBUTTON_HIT));
	rb_define_const(cSwf_button, "DOWN", INT2FIX(SWFBUTTON_DOWN));
	rb_define_const(cSwf_button, "OVER", INT2FIX(SWFBUTTON_OVER));
	rb_define_const(cSwf_button, "UP", INT2FIX(SWFBUTTON_UP));
	
	rb_define_const(cSwf_button, "MOUSEUPOUTSIDE", INT2FIX(SWFBUTTON_MOUSEUPOUTSIDE));
	rb_define_const(cSwf_button, "DRAGOVER", INT2FIX(SWFBUTTON_DRAGOVER));
	rb_define_const(cSwf_button, "DRAGOUT", INT2FIX(SWFBUTTON_DRAGOUT));
	rb_define_const(cSwf_button, "MOUSEUP", INT2FIX(SWFBUTTON_MOUSEUP));
	rb_define_const(cSwf_button, "MOUSEDOWN", INT2FIX(SWFBUTTON_MOUSEDOWN));
	rb_define_const(cSwf_button, "MOUSEOUT", INT2FIX(SWFBUTTON_MOUSEOUT));
	rb_define_const(cSwf_button, "MOUSEOVER", INT2FIX(SWFBUTTON_MOUSEOVER));
}
