#include "init.h"

void
swf_no_font()
{
	rb_raise(rb_eRuntimeError, "already closed font");
}

static void
swf_free_font(p)
	SWFFont p;
{
	Debug("swf free font");
	destroySWFFont(p);
}

static VALUE
swf_font_new(argc, argv, self)
	int argc;
	VALUE *argv;
	VALUE self;
{
	VALUE obj;
	SWFFont p;
	VALUE fontname;
	
	if (rb_scan_args(argc, argv, "01", &fontname) == 1) {
		char *name;
		
		name = STR2CSTR(fontname);
		if (strlen(name) > 4 && strcmp(name + strlen(name) - 4, ".fdb") == 0)
			p = loadSWFFontFromFile(fopen(name, "rb"));
		else
			p = newSWFBrowserFont(name);
	} else
		p = newSWFFont();
	if (p)
		obj = Data_Wrap_Struct(self, 0, swf_free_font, p);
	else
		obj = Qnil;
	
	return obj;
}

VALUE
swf_font_alloc(self, p)
	VALUE self;
	SWFFont p;
{
	VALUE obj;
	
	obj = Data_Wrap_Struct(self, 0, 0, p);
	return obj;
}

static VALUE
swf_font_get_string_width(self, str)
	VALUE self, str;
{
	SWFFont p;
	
	GetFont(self, p);
	return INT2FIX(SWFFont_getStringWidth(p, STR2CSTR(str)));
}

static VALUE
swf_font_get_ascent(self)
	VALUE self;
{
	SWFFont p;
	
	GetFont(self, p);
	return INT2FIX(SWFFont_getAscent(p));
}

static VALUE
swf_font_get_descent(self)
	VALUE self;
{
	SWFFont p;
	
	GetFont(self, p);
	return INT2FIX(SWFFont_getDescent(p));
}

static VALUE
swf_font_get_leading(self)
	VALUE self;
{
	SWFFont p;
	
	GetFont(self, p);
	return INT2FIX(SWFFont_getLeading(p));
}

void
swf_init_font()
{
	cSwf_font = rb_define_class_under(mSwf, "Font", rb_cObject);
	rb_define_singleton_method(cSwf_font, "new", swf_font_new, -1);
	rb_define_method(cSwf_font, "get_string_width", swf_font_get_string_width, 1);
	rb_define_method(cSwf_font, "ascent", swf_font_get_ascent, 0);
	rb_define_method(cSwf_font, "descent", swf_font_get_descent, 0);
	rb_define_method(cSwf_font, "leading", swf_font_get_leading, 0);
}
