#include "init.h"

void
swf_no_TextField()
{
	rb_raise(rb_eRuntimeError, "already closed TextField");
}

static void
swf_free_TextField(p)
	SWFTextField p;
{
	Debug("swf free TextField");
	destroySWFTextField(p);
}

static VALUE
swf_TextField_new(self)
	VALUE self;
{
	VALUE obj;
	SWFTextField p;
	
	p = newSWFTextField();
	obj = Data_Wrap_Struct(self, 0, swf_free_TextField, p);
	return obj;
}

VALUE
swf_TextField_alloc(self, p)
	VALUE self;
	SWFTextField p;
{
	VALUE obj;
	
	obj = Data_Wrap_Struct(self, 0, 0, p);
	return obj;
}

static VALUE
swf_TextField_set_font(self, v)
	VALUE self, v;
{
	SWFTextField p;
	SWFBlock p_font;
	
	GetTextField(self, p);
	GetBlock(v, p_font);
	SWFTextField_setFont(p, p_font);
	return v;
}

static VALUE
swf_TextField_set_bounds(self, width, height)
	VALUE self, width, height;
{
	SWFTextField p;
	
	GetTextField(self, p);
	SWFTextField_setBounds(p, NUM2INT(width), NUM2INT(height));
	return Qnil;
}

static VALUE
swf_TextField_set_flags(self, v)
	VALUE self, v;
{
	SWFTextField p;
	
	GetTextField(self, p);
	SWFTextField_setFlags(p, NUM2INT(v));
	return v;
}

static VALUE
swf_TextField_set_color(argc, argv, self)
	int argc;
	VALUE* argv;
	VALUE self;
{
	SWFTextField p;
	SWFFill p_fill;
	VALUE r, g, b, a;
	
	if (rb_scan_args(argc, argv, "31", &r, &g, &b, &a) == 3)
		a = INT2FIX(0xff);
	GetTextField(self, p);
	SWFTextField_setColor(p, 
		(byte)(NUM2CHR(r)),
		(byte)(NUM2CHR(g)),
		(byte)(NUM2CHR(b)),
		(byte)(NUM2CHR(a)));
	return Qnil;
}

static VALUE
swf_TextField_set_name(self, v)
	VALUE self, v;
{
	SWFTextField p;
	
	GetTextField(self, p);
	SWFTextField_setVariableName(p, STR2CSTR(v));
	return v;
}

static VALUE
swf_TextField_add_string(self, str)
	VALUE self, str;
{
	SWFTextField p;
	
	GetTextField(self, p);
	SWFTextField_addString(p, STR2CSTR(str));
	return Qnil;
}

static VALUE
swf_TextField_set_height(self, v)
	VALUE self, v;
{
	SWFTextField p;
	
	GetTextField(self, p);
	SWFTextField_setHeight(p, NUM2INT(v));
	return v;
}

static VALUE
swf_TextField_set_left_margin(self, v)
	VALUE self, v;
{
	SWFTextField p;
	
	GetTextField(self, p);
	SWFTextField_setLeftMargin(p, NUM2INT(v));
	return v;
}

static VALUE
swf_TextField_set_right_margin(self, v)
	VALUE self, v;
{
	SWFTextField p;
	
	GetTextField(self, p);
	SWFTextField_setRightMargin(p, NUM2INT(v));
	return v;
}

static VALUE
swf_TextField_set_indent(self, v)
	VALUE self, v;
{
	SWFTextField p;
	
	GetTextField(self, p);
	SWFTextField_setIndentation(p, NUM2INT(v));
	return v;
}

static VALUE
swf_TextField_set_spacing(self, v)
	VALUE self, v;
{
	SWFTextField p;
	
	GetTextField(self, p);
	SWFTextField_setLineSpacing(p, NUM2INT(v));
	return v;
}

static VALUE
swf_TextField_set_align(self, v)
	VALUE self, v;
{
	SWFTextField p;
	
	GetTextField(self, p);
	SWFTextField_setAlignment(p, NUM2INT(v));
	return v;
}

static VALUE
swf_TextField_set_length(self, v)
	VALUE self, v;
{
	SWFTextField p;
	
	GetTextField(self, p);
	SWFTextField_setLength(p, NUM2INT(v));
	return v;
}

void
swf_init_TextField()
{
	cSwf_TextField = rb_define_class_under(mSwf, "TextField", rb_cObject);
	rb_define_singleton_method(cSwf_TextField, "new", swf_TextField_new, 0);
	rb_define_method(cSwf_TextField, "font=", swf_TextField_set_font, 1);
	rb_define_method(cSwf_TextField, "set_bounds", swf_TextField_set_bounds, 2);
	rb_define_method(cSwf_TextField, "flags=", swf_TextField_set_flags, 1);
	rb_define_method(cSwf_TextField, "set_color", swf_TextField_set_color, -1);
	rb_define_method(cSwf_TextField, "name=", swf_TextField_set_name, 1);
	rb_define_method(cSwf_TextField, "add_string", swf_TextField_add_string, 1);
	rb_define_method(cSwf_TextField, "height=", swf_TextField_set_height, 1);
	rb_define_method(cSwf_TextField, "left_margin=", swf_TextField_set_left_margin, 1);
	rb_define_method(cSwf_TextField, "right_margin=", swf_TextField_set_right_margin, 1);
	rb_define_method(cSwf_TextField, "indent=", swf_TextField_set_indent, 1);
	rb_define_method(cSwf_TextField, "spacing=", swf_TextField_set_spacing, 1);
	rb_define_method(cSwf_TextField, "align=", swf_TextField_set_align, 1);
	rb_define_method(cSwf_TextField, "length=", swf_TextField_set_length, 1);
	
	rb_define_const(cSwf_TextField, "HASLENGTH", INT2FIX(SWFTEXTFIELD_HASLENGTH));
	rb_define_const(cSwf_TextField, "NOEDIT", INT2FIX(SWFTEXTFIELD_NOEDIT));
	rb_define_const(cSwf_TextField, "PASSWORD", INT2FIX(SWFTEXTFIELD_PASSWORD));
	rb_define_const(cSwf_TextField, "MULTILINE", INT2FIX(SWFTEXTFIELD_MULTILINE));
	rb_define_const(cSwf_TextField, "WORDWRAP", INT2FIX(SWFTEXTFIELD_WORDWRAP));
	rb_define_const(cSwf_TextField, "DRAWBOX", INT2FIX(SWFTEXTFIELD_DRAWBOX));
	rb_define_const(cSwf_TextField, "NOSELECT", INT2FIX(SWFTEXTFIELD_NOSELECT));

	rb_define_const(cSwf_TextField, "ALIGN_LEFT", INT2FIX(SWFTEXTFIELD_ALIGN_LEFT));
	rb_define_const(cSwf_TextField, "ALIGN_RIGHT", INT2FIX(SWFTEXTFIELD_ALIGN_RIGHT));
	rb_define_const(cSwf_TextField, "ALIGN_CENTER", INT2FIX(SWFTEXTFIELD_ALIGN_CENTER));
	rb_define_const(cSwf_TextField, "ALIGN_JUSTIFY", INT2FIX(SWFTEXTFIELD_ALIGN_JUSTIFY));
}
